/************************************************************************************
managementofareamapirs
Copyright (c) 2010, International Rescue System Institute
All rights reserved.

Contact us if you use this software for sell.
If you use this software not for sell, you can use this software under BSD license.
See the files LICENSE.TXT and LICENSE-BSD.TXT for more details.                     
************************************************************************************/

//***********************************************************************************************//
//* main.cpp									     2010.03.17 *//
//*												*//
//* GTK+ モニタリングプログラム									*//
//***********************************************************************************************//


//-- [ヘッダファイル] ---------------------------------------------------------------------------//
#include <stdlib.h>											// stdlibヘッダファイル読み込み
#include <gtk/gtk.h>											// gtk/gtkヘッダファイル読み込み
#include <glade/glade.h>										// glade/gladeヘッダファイル読み込み
#include "udp.h"											// udpヘッダファイル読み込み
//-----------------------------------------------------------------------------------------------//


//-- [置換] -------------------------------------------------------------------------------------//
#define BUFSIZE		128										// 最大送受信文字数
#define DATASIZE	256										// 最大データ文字数
#define FONTSTYLE	"Liberation Sans"								// フォントスタイル
#define DEBUG_COMMAND_LINE										// DEBUG定義 [デバッグ用]
//-----------------------------------------------------------------------------------------------//


//-- [コールバック関数プロトタイプ宣言] ---------------------------------------------------------//
G_BEGIN_DECLS
void udp_read_callback(gpointer, gint, GdkInputCondition);						// UDPデータ受信イベント
gboolean drawingarea_expose_event(GtkWidget*, GdkEventExpose*, gpointer);				// エクスポーズイベント
void window_destroy(GtkWidget*);									// ウィンドウ破棄イベント
G_END_DECLS
//-----------------------------------------------------------------------------------------------//


//-- [変数宣言] ---------------------------------------------------------------------------------//
char send_data[BUFSIZE];										// 送信データ格納配列
char recv_data[BUFSIZE];										// 受信データ格納配列
int send_sock;												// ソケットディスクリプタ格納変数
int recv_sock;												// ソケットディスクリプタ格納変数
int recv_len;												// 受信サイズ格納変数
unsigned long square[4];										// 矩形データ格納配列
struct sockaddr_in send_addr;										// アドレス格納構造体
struct sockaddr_in recv_addr;										// アドレス格納構造体
socklen_t addr_size;											// アドレス格納構造体サイズ格納変数
GtkWidget *drawingarea;											// 画像 [drawingarea]
GtkWidget *explanationlabel;										// ラベル [explanationlabel]
GtkWidget *locationlabel;										// ラベル [locationlabel]
GtkWidget *timestamplabel;										// ラベル [timestamplabel]
GtkWidget *modelabel;											// ラベル [modelabel]
GtkWidget *mapsetlabel;											// ラベル [mapsetlabel]
GtkWidget *typelabel;											// ラベル [typelabel]
GtkWidget *originxlabel;										// ラベル [originxlabel]
GtkWidget *originylabel;										// ラベル [originylabel]
GtkWidget *sizexlabel;											// ラベル [sizexlabel]
GtkWidget *sizeylabel;											// ラベル [sizeylabel]
GtkWidget *maporiginxlabel;										// ラベル [maporiginxlabel]
GtkWidget *maporiginylabel;										// ラベル [maporiginylabel]
GtkWidget *mapsizexlabel;										// ラベル [mapsizexlabel]
GtkWidget *mapsizeylabel;										// ラベル [mapsizeylabel]
GtkWidget *pixelsizexlabel;										// ラベル [pixelsizexlabel]
GtkWidget *pixelsizeylabel;										// ラベル [pixelsizeylabel]
GtkWidget *categorylabel;										// ラベル [categorylabel]
GtkWidget *explanation;											// ラベル [explanation]
GtkWidget *location;											// ラベル [location]
GtkWidget *timestamp;											// ラベル [timestamp]
GtkWidget *mode;											// ラベル [mode]
GtkWidget *mapset;											// ラベル [mapset]
GtkWidget *type;											// ラベル [type]
GtkWidget *originx;											// ラベル [originx]
GtkWidget *originy;											// ラベル [originy]
GtkWidget *sizex;											// ラベル [sizex]
GtkWidget *sizey;											// ラベル [sizey]
GtkWidget *maporiginx;											// ラベル [maporiginx]
GtkWidget *maporiginy;											// ラベル [maporiginy]
GtkWidget *mapsizex;											// ラベル [mapsizex]
GtkWidget *mapsizey;											// ラベル [mapsizey]
GtkWidget *pixelsizex;											// ラベル [pixelsizex]
GtkWidget *pixelsizey;											// ラベル [pixelsizey]
GtkWidget *category1;											// ラベル [category1]
GtkWidget *category2;											// ラベル [category2]
GtkWidget *category3;											// ラベル [category3]
GtkWidget *category4;											// ラベル [category4]
GtkWidget *category5;											// ラベル [category5]
GtkWidget *category6;											// ラベル [category6]
GtkWidget *category7;											// ラベル [category7]
GtkWidget *category8;											// ラベル [category8]
GtkWidget *category9;											// ラベル [category9]
GtkWidget *category10;											// ラベル [category10]
GdkPixbuf *pixbuf;											// バッファ [pixbuf]
GdkColor color;												// 色 [color]
//-----------------------------------------------------------------------------------------------//


//-- [UDPデータ受信イベント] --------------------------------------------------------------------//
//- void udp_read_callback(gpointer data, gint source, GdkInputCondition condition)		-//
//- 機能  ：UDPのデータ受信処理を行う								-//
//- 引数  ：(gpointer)          関数引き渡しユーザデータ [gtk_input_add, gtk_input_add_full]	-//
//-       ：(gint)              条件が発生するファイルディスクリプタ				-//
//-       ：(GdkInputCondition) トリガー条件							-//
//- 戻り値：(void)              なし								-//
//-----------------------------------------------------------------------------------------------//
void udp_read_callback(gpointer data, gint source, GdkInputCondition condition)
{


	//-- [変数宣言] -------------------------------------------------------------------------//

	int ratio;											// 比率格納変数
	double size;											// サイズ格納変数
	long min_x;											// x最小値格納変数
	long max_x;											// x最大値格納変数
	long min_y;											// y最小値格納変数
	long max_y;											// y最大値格納変数
	unsigned long i;										// カウンタ格納変数
	unsigned long j;										// カウンタ格納変数
	unsigned long k;										// カウンタ格納変数
	unsigned long cat_num;										// カテゴリファイル行数格納変数
	unsigned long arc_size;										// アークデータ数格納変数
	unsigned long node_size;									// ノードデータ数格納変数
	unsigned long id;										// ノードID格納変数
	unsigned long width;										// 画像幅格納変数
	unsigned long height;										// 画像高さ格納変数
	unsigned long rowstride;									// 一行サイズ格納変数
	unsigned long x1;										// x座標格納変数
	unsigned long x2;										// x座標格納変数
	unsigned long y1;										// y座標格納変数
	unsigned long y2;										// y座標格納変数
	double a;											// 傾き格納変数
	double b;											// オフセット格納変数
	char filename[DATASIZE];									// ファイル名格納配列
	char message[11][DATASIZE];									// メッセージ格納配列
	char chline[2 * DATASIZE];									// 処理用行列格納配列
	char label[27][DATASIZE];									// ラベル格納配列
	FILE *fd;											// ファイルディスクリプタ格納変数
	long *px;											// x座標格納変数ポインタ
	long *py;											// y座標格納変数ポインタ
	double *ptheta;											// 方向格納配列ポインタ
	char *pexplanation;										// 説明格納配列ポインタ
	unsigned long *pstartid;									// 接続開始ノード格納変数ポインタ
	unsigned long *pendid;										// 接続終了ノード格納変数ポインタ
	double *pcost;											// コスト格納変数ポインタ
	GdkWindow *drawable;										// ドローアブル [drawable]
	GdkGC *gc;											// グラフィックコンテキスト [gc]
	guchar *pixels;											// ピクセルデータ格納ポインタ

	//---------------------------------------------------------------------------------------//


	//-- [初期化] ---------------------------------------------------------------------------//

	for(i = 0; i < 11; i++) strcpy(message[i], "");							// メッセージ初期化

	//---------------------------------------------------------------------------------------//


	//-- [受信データクリア] -----------------------------------------------------------------//

	memset(recv_data, 0, sizeof(recv_data));							// バッファクリア

	//---------------------------------------------------------------------------------------//


	//-- [受信処理] -------------------------------------------------------------------------//

	recv_len = recvfrom(recv_sock, recv_data, sizeof(recv_data), 0,
		(struct sockaddr *)&recv_addr, &addr_size);						// データ受信

	if(recv_len < 0){

		printf("receive error!!\n");								// メッセージ表示
		fflush(stdout);										// バッファフラッシュ [printf表示用]

	}

	j = 0;												// カウンタリセット
	k = 0;												// カウンタリセット

	for(i = 0; i < (unsigned long)recv_len; i++){

		if(recv_data[i] != ','){

			message[k][j] = recv_data[i];							// データ格納
			j++;										// カウント

		}else{

			message[k][j] = 0x00;								// 終端文字処理
			j = 0;										// カウンタリセット
			k++;										// カウント

		}

	}

	message[k][j] = 0x00;										// 終端文字処理

	//---------------------------------------------------------------------------------------//


	//-- [プログラム終了処理] ---------------------------------------------------------------//

	if(strcmp("quit", recv_data) == 0){

		close(send_sock);									// ソケットディスクリプタクローズ
		close(recv_sock);									// ソケットディスクリプタクローズ
		gtk_main_quit();									// メッセージループ回避

	//---------------------------------------------------------------------------------------//


	//-- [ラベル処理] -----------------------------------------------------------------------//

	}else{


		//-- [ラスターデータ読み込み] ---------------------------------------------------//

		if(((atoi(message[3]) & 0x0002) == 0x00)
			&& (((atoi(message[3])) & 0x0001) == 0x0000)){					// モードチェック


			//-- [ラベル処理] -------------------------------------------------------//

			gtk_label_set_text((GtkLabel *)explanationlabel, "EXPLANATION");		// ラベル表示 [explanationlabel]
			gtk_label_set_text((GtkLabel *)locationlabel, "LOCATION");			// ラベル表示 [locationlabel]
			gtk_label_set_text((GtkLabel *)timestamplabel, "TIMESTAMP");			// ラベル表示 [timestamplabel]
			gtk_label_set_text((GtkLabel *)modelabel, "MODE");				// ラベル表示 [modelabel]
			gtk_label_set_text((GtkLabel *)mapsetlabel, "MAPSET");				// ラベル表示 [mapsetlabel]
			gtk_label_set_text((GtkLabel *)typelabel, "TYPE");				// ラベル表示 [typelabel]
			gtk_label_set_text((GtkLabel *)originxlabel, "ORIGIN X");			// ラベル表示 [originxlabel]
			gtk_label_set_text((GtkLabel *)originylabel, "ORIGIN Y");			// ラベル表示 [originylabel]
			gtk_label_set_text((GtkLabel *)sizexlabel, "SIZE X");				// ラベル表示 [sizexlabel]
			gtk_label_set_text((GtkLabel *)sizeylabel, "SIZE Y");				// ラベル表示 [sizeylabel]
			gtk_label_set_text((GtkLabel *)maporiginxlabel, "MAP ORIGIN X");		// ラベル表示 [maporiginxlabel]
			gtk_label_set_text((GtkLabel *)maporiginylabel, "MAP ORIGIN Y");		// ラベル表示 [maporiginylabel]
			gtk_label_set_text((GtkLabel *)mapsizexlabel, "MAP SIZE X");			// ラベル表示 [mapsizexlabel]
			gtk_label_set_text((GtkLabel *)mapsizeylabel, "MAP SIZE Y");			// ラベル表示 [mapsizeylabel]
			gtk_label_set_text((GtkLabel *)pixelsizexlabel, "PIXEL SIZE X");		// ラベル表示 [pixelsizexlabel]
			gtk_label_set_text((GtkLabel *)pixelsizeylabel, "PIXEL SIZE Y");		// ラベル表示 [pixelsizeylabel]
			gtk_label_set_text((GtkLabel *)categorylabel, "CATEGORY");			// ラベル表示 [categorylabel]
			gtk_label_set_text((GtkLabel *)explanation, "");				// ラベル表示 [explanation]
			gtk_label_set_text((GtkLabel *)location, "");					// ラベル表示 [location]
			gtk_label_set_text((GtkLabel *)timestamp, "");					// ラベル表示 [timestamp]
			gtk_label_set_text((GtkLabel *)mode, "");					// ラベル表示 [mode]
			gtk_label_set_text((GtkLabel *)mapset, "");					// ラベル表示 [mapset]
			gtk_label_set_text((GtkLabel *)type, "");					// ラベル表示 [type]
			gtk_label_set_text((GtkLabel *)originx, "");					// ラベル表示 [originx]
			gtk_label_set_text((GtkLabel *)originy, "");					// ラベル表示 [originy]
			gtk_label_set_text((GtkLabel *)sizex, "");					// ラベル表示 [sizex]
			gtk_label_set_text((GtkLabel *)sizey, "");					// ラベル表示 [sizey]
			gtk_label_set_text((GtkLabel *)maporiginx, "");					// ラベル表示 [maporiginx]
			gtk_label_set_text((GtkLabel *)maporiginy, "");					// ラベル表示 [maporiginy]
			gtk_label_set_text((GtkLabel *)mapsizex, "");					// ラベル表示 [mapsizex]
			gtk_label_set_text((GtkLabel *)mapsizey, "");					// ラベル表示 [mapsizey]
			gtk_label_set_text((GtkLabel *)pixelsizex, "");					// ラベル表示 [pixelsizex]
			gtk_label_set_text((GtkLabel *)pixelsizey, "");					// ラベル表示 [pixelsizey]
			gtk_label_set_text((GtkLabel *)category1, "");					// ラベル表示 [category1]
			gtk_label_set_text((GtkLabel *)category2, "");					// ラベル表示 [category2]
			gtk_label_set_text((GtkLabel *)category3, "");					// ラベル表示 [category3]
			gtk_label_set_text((GtkLabel *)category4, "");					// ラベル表示 [category4]
			gtk_label_set_text((GtkLabel *)category5, "");					// ラベル表示 [category5]
			gtk_label_set_text((GtkLabel *)category6, "");					// ラベル表示 [category6]
			gtk_label_set_text((GtkLabel *)category7, "");					// ラベル表示 [category7]
			gtk_label_set_text((GtkLabel *)category8, "");					// ラベル表示 [category8]
			gtk_label_set_text((GtkLabel *)category9, "");					// ラベル表示 [category9]
			gtk_label_set_text((GtkLabel *)category10, "");					// ラベル表示 [category10]

			//-----------------------------------------------------------------------//


			//-- [ヘッダファイル処理] -----------------------------------------------//


			//-- [ヘッダファイルアドレス設定] ---------------------------------------//

			strcpy(filename, message[0]);							// robotマップアドレス
			strcat(filename, message[4]);							// 地域名
			strcat(filename, "/");								// スラッシュ
			strcat(filename, message[5]);							// 利用者マップセット
			strcat(filename, "/");								// スラッシュ
			strcat(filename, message[6]);							// データタイプ
			strcat(filename, "0000r.ini");							// ファイル名

			//-----------------------------------------------------------------------//


			//-- [ファイルオープン] -------------------------------------------------//

			fd = fopen(filename, "r");							// ファイルオープン

			if(fd == NULL){

				printf("file open error!!\n");						// メッセージ表示
				fflush(stdout);								// バッファフラッシュ [printf表示用]

				gtk_main_quit();							// メッセージループ回避

			}

			//-----------------------------------------------------------------------//


			//-- [ヘッダデータ格納] -------------------------------------------------//

			i = 0;										// カウンタリセット
			while((label[0][i] = fgetc(fd)) != ':') i++;					// ラベル格納 [explanation]
			label[0][i] = 0x00;								// 終端文字処理

			if(strcmp(label[0], "explanation") != 0){					// ラベルチェック [explanation]

				printf("headerfile:explanation error = %s\n", label[0]);		// エラーメッセージ
				fflush(stdout);								// バッファフラッシュ [printf表示用]

				gtk_main_quit();							// メッセージループ回避

			}

			strcpy(label[0], ": ");								// コロン
			i = 2;										// カウンタリセット
			while((label[0][i] = fgetc(fd)) != '\n') i++;					// データ格納 [explanation]
			label[0][i] = 0x00;								// 終端文字処理

			i = 0;										// カウンタリセット
			while((label[10][i] = fgetc(fd)) != ':') i++;					// ラベル格納 [origin_x]
			label[10][i] = 0x00;								// 終端文字処理

			if(strcmp(label[10], "origin_x") != 0){						// ラベルチェック [origin_x]

				printf("headerfile:origin_x error = %s\n", label[10]);			// エラーメッセージ
				fflush(stdout);								// バッファフラッシュ [printf表示用]

				gtk_main_quit();							// メッセージループ回避

			}

			i = 0;										// カウンタリセット
			while((label[10][i] = fgetc(fd)) != '\n') i++;					// データ格納 [origin_x]
			label[10][i] = 0x00;								// 終端文字処理

			i = 0;										// カウンタリセット
			while((label[11][i] = fgetc(fd)) != ':') i++;					// ラベル格納 [origin_y]
			label[11][i] = 0x00;								// 終端文字処理

			if(strcmp(label[11], "origin_y") != 0){						// ラベルチェック [origin_y]

				printf("headerfile:origin_y error = %s\n", label[11]);			// エラーメッセージ
				fflush(stdout);								// バッファフラッシュ [printf表示用]

				gtk_main_quit();							// メッセージループ回避

			}

			i = 0;										// カウンタリセット
			while((label[11][i] = fgetc(fd)) != '\n') i++;					// データ格納 [origin_y]
			label[11][i] = 0x00;								// 終端文字処理

			i = 0;										// カウンタリセット
			while((label[14][i] = fgetc(fd)) != ':') i++;					// ラベル格納 [size_x]
			label[14][i] = 0x00;								// 終端文字処理

			if(strcmp(label[14], "size_x") != 0){						// ラベルチェック [size_x]

				printf("headerfile:size_x error = %s\n", label[14]);			// エラーメッセージ
				fflush(stdout);								// バッファフラッシュ [printf表示用]

				gtk_main_quit();							// メッセージループ回避

			}

			i = 0;										// カウンタリセット
			while((label[14][i] = fgetc(fd)) != '\n') i++;					// データ格納 [size_x]
			label[14][i] = 0x00;								// 終端文字処理

			i = 0;										// カウンタリセット
			while((label[15][i] = fgetc(fd)) != ':') i++;					// ラベル格納 [size_y]
			label[15][i] = 0x00;								// 終端文字処理

			if(strcmp(label[15], "size_y") != 0){						// ラベルチェック [size_y]

				printf("headerfile:size_y error = %s\n", label[15]);			// エラーメッセージ
				fflush(stdout);								// バッファフラッシュ [printf表示用]

				gtk_main_quit();							// メッセージループ回避

			}

			i = 0;										// カウンタリセット
			while((label[15][i] = fgetc(fd)) != '\n') i++;					// データ格納 [size_y]
			label[15][i] = 0x00;								// 終端文字処理

			//-----------------------------------------------------------------------//


			//-- [ファイルクローズ] -------------------------------------------------//

			fclose(fd);									// ファイルクローズ

			//-----------------------------------------------------------------------//


			//-----------------------------------------------------------------------//


			//-- [カテゴリファイル処理] ---------------------------------------------//


			//-- [カテゴリファイルアドレス設定] -------------------------------------//

			strcpy(filename, message[0]);							// robotマップアドレス
			strcat(filename, message[4]);							// 地域名
			strcat(filename, "/");								// スラッシュ
			strcat(filename, message[5]);							// 利用者マップセット
			strcat(filename, "/");								// スラッシュ
			strcat(filename, message[6]);							// データタイプ
			strcat(filename, "0000r.cat");							// ファイル名

			//-----------------------------------------------------------------------//


			//-- [ファイルオープン] -------------------------------------------------//

			fd = fopen(filename, "r");							// ファイルオープン

			if(fd == NULL){

				printf("file open error!!\n");						// メッセージ表示
				fflush(stdout);								// バッファフラッシュ [printf表示用]

				gtk_main_quit();							// メッセージループ回避

			}

			//-----------------------------------------------------------------------//


			//-- [行数チェック] -----------------------------------------------------//

			cat_num = 0;									// 行数初期化
			while(fgets(chline, 256, fd) != NULL) cat_num++;				// 行数カウント
			if(cat_num >= 10) strcpy(label[25], "...etc");					// カテゴリ10
			else strcpy(label[25], "");							// カテゴリ10

			//-----------------------------------------------------------------------//


			//-- [ファイルクローズ] -------------------------------------------------//

			fclose(fd);									// ファイルクローズ

			//-----------------------------------------------------------------------//


			//-- [ファイルオープン] -------------------------------------------------//

			fd = fopen(filename, "r");							// ファイルオープン

			if(fd == NULL){

				printf("file open error!!\n");						// メッセージ表示
				fflush(stdout);								// バッファフラッシュ [printf表示用]

				gtk_main_quit();							// メッセージループ回避

			}

			//-----------------------------------------------------------------------//


			//-- [カテゴリデータ格納] -----------------------------------------------//

			if(cat_num >= 1) fscanf(fd, "%s\n", label[16]);					// カテゴリ1
			else strcpy(label[16], "");							// カテゴリ1

			if(cat_num >= 2) fscanf(fd, "%s\n", label[17]);					// カテゴリ2
			else strcpy(label[17], "");							// カテゴリ2

			if(cat_num >= 3) fscanf(fd, "%s\n", label[18]);					// カテゴリ3
			else strcpy(label[18], "");							// カテゴリ3

			if(cat_num >= 4) fscanf(fd, "%s\n", label[19]);					// カテゴリ4
			else strcpy(label[19], "");							// カテゴリ4

			if(cat_num >= 5) fscanf(fd, "%s\n", label[20]);					// カテゴリ5
			else strcpy(label[20], "");							// カテゴリ5

			if(cat_num >= 6) fscanf(fd, "%s\n", label[21]);					// カテゴリ6
			else strcpy(label[21], "");							// カテゴリ6

			if(cat_num >= 7) fscanf(fd, "%s\n", label[22]);					// カテゴリ7
			else strcpy(label[22], "");							// カテゴリ7

			if(cat_num >= 8) fscanf(fd, "%s\n", label[23]);					// カテゴリ8
			else strcpy(label[23], "");							// カテゴリ8

			if(cat_num >= 9) fscanf(fd, "%s\n", label[24]);					// カテゴリ9
			else strcpy(label[24], "");							// カテゴリ9

			//-----------------------------------------------------------------------//


			//-- [ファイルクローズ] -------------------------------------------------//

			fclose(fd);									// ファイルクローズ

			//-----------------------------------------------------------------------//


			//-----------------------------------------------------------------------//


			//-- [ビットマップファイル処理] -----------------------------------------//


			//-- [ビットマップファイルアドレス設定] ---------------------------------//

			strcpy(filename, message[0]);							// robotマップアドレス
			strcat(filename, message[4]);							// 地域名
			strcat(filename, "/");								// スラッシュ
			strcat(filename, message[5]);							// 利用者マップセット
			strcat(filename, "/");								// スラッシュ
			strcat(filename, message[6]);							// データタイプ
			strcat(filename, "0000r.bmp");							// ファイル名

			//-----------------------------------------------------------------------//


			//-- [地図情報格納処理] -------------------------------------------------//

			pixbuf = gdk_pixbuf_new_from_file(filename, NULL);				// バッファ生成 [pixbuf]

			if(strcmp("0", message[9]) == 0)
				strcpy(label[12], "0");							// ピクセルサイズx座標
			else
				sprintf(label[12], "%d",
					gdk_pixbuf_get_width(pixbuf) * atoi(label[14]));		// ピクセルサイズx座標

			if(strcmp("0", message[10]) == 0)
				strcpy(label[13], "0");							// ピクセルサイズy座標
			else
				sprintf(label[13], "%d",
					gdk_pixbuf_get_height(pixbuf) * atoi(label[15]));		// ピクセルサイズy座標

			if(gdk_pixbuf_get_width(pixbuf) > gdk_pixbuf_get_height(pixbuf))
				ratio = (gdk_pixbuf_get_width(pixbuf)
					/ drawingarea->allocation.width) + 1;				// 比率格納
			else ratio = (gdk_pixbuf_get_height(pixbuf)
					/ drawingarea->allocation.height) + 1;				// 比率格納

			square[0] = ((atol(message[7]) - atol(label[10])) / atoi(label[14])) / ratio;	// 描画原点x座標設定
			square[1] = ((gdk_pixbuf_get_height(pixbuf) * atoi(label[15]) + atol(label[11])
					- atol(message[8]) - atol(message[10]))
					/ atoi(label[15])) / ratio;					// 描画原点y座標設定
			square[2] = (atol(message[9])  / atoi(label[14])) / ratio;			// 描画範囲x座標設定
			square[3] = (atol(message[10]) / atoi(label[15])) / ratio;			// 描画範囲y座標設定

			pixbuf = gdk_pixbuf_scale_simple(pixbuf,
				(gdk_pixbuf_get_width(pixbuf)) / ratio,
				(gdk_pixbuf_get_height(pixbuf)) / ratio, GDK_INTERP_NEAREST);		// 画像比率変更

			gtk_widget_set_size_request(drawingarea, gdk_pixbuf_get_width(pixbuf),
				gdk_pixbuf_get_height(pixbuf));						// 画像サイズ設定

			//-----------------------------------------------------------------------//


			//-----------------------------------------------------------------------//


			//-- [ラベル表示処理] ---------------------------------------------------//

			gtk_label_set_text((GtkLabel *)explanation, label[0]);				// ラベル表示 [explanation]

			strcpy(label[1], ": ");								// コロン
			strcat(label[1], message[0]);							// robotマップアドレス
			strcat(label[1], message[4]);							// 地域名
			gtk_label_set_text((GtkLabel *)location, label[1]);				// ラベル表示 [location]

			strcpy(label[2], ": ");								// コロン
			strcat(label[2], message[1]);							// タイムスタンプ
			gtk_label_set_text((GtkLabel *)timestamp, label[2]);				// ラベル表示 [timestamp]

			strcpy(label[3], ": ");								// コロン
			strcat(label[3], message[3]);							// アクセスモード
			gtk_label_set_text((GtkLabel *)mode, label[3]);					// ラベル表示 [mode]

			strcpy(label[4], ": ");								// コロン
			strcat(label[4], message[5]);							// 利用者マップセット名
			gtk_label_set_text((GtkLabel *)mapset, label[4]);				// ラベル表示 [mapset]

			strcpy(label[5], ": ");								// コロン
			strcat(label[5], message[6]);							// データタイプ
			gtk_label_set_text((GtkLabel *)type, label[5]);					// ラベル表示 [type]

			strcpy(label[6], ": ");								// コロン
			strcat(label[6], message[7]);							// 対象原点x座標
			gtk_label_set_text((GtkLabel *)originx, label[6]);				// ラベル表示 [originx]

			strcpy(label[7], ": ");								// コロン
			strcat(label[7], message[8]);							// 対象原点y座標
			gtk_label_set_text((GtkLabel *)originy, label[7]);				// ラベル表示 [originy]

			strcpy(label[8], ": ");								// コロン
			strcat(label[8], message[9]);							// 対象範囲x座標
			gtk_label_set_text((GtkLabel *)sizex, label[8]);				// ラベル表示 [sizex]

			strcpy(label[9], ": ");								// コロン
			strcat(label[9], message[10]);							// 対象範囲y座標
			gtk_label_set_text((GtkLabel *)sizey, label[9]);				// ラベル表示 [sizey]

			sprintf(label[27], ": %s", label[10]);						// 地図原点x座標
			gtk_label_set_text((GtkLabel *)maporiginx, label[27]);				// ラベル表示 [maporiginx]

			sprintf(label[27], ": %s", label[11]);						// 地図原点y座標
			gtk_label_set_text((GtkLabel *)maporiginy, label[27]);				// ラベル表示 [maporiginy]

			sprintf(label[27], ": %s", label[12]);						// 地図サイズx座標
			gtk_label_set_text((GtkLabel *)mapsizex, label[27]);				// ラベル表示 [mapsizex]

			sprintf(label[27], ": %s", label[13]);						// 地図サイズy座標
			gtk_label_set_text((GtkLabel *)mapsizey, label[27]);				// ラベル表示 [mapsizey]

			sprintf(label[27], ": %s", label[14]);						// ピクセルサイズx座標
			gtk_label_set_text((GtkLabel *)pixelsizex, label[27]);				// ラベル表示 [pixelsizex]

			sprintf(label[27], ": %s", label[15]);						// ピクセルサイズy座標
			gtk_label_set_text((GtkLabel *)pixelsizey, label[27]);				// ラベル表示 [pixelsizey]

			gtk_label_set_text((GtkLabel *)category1, label[16]);				// ラベル表示 [category1]

			gtk_label_set_text((GtkLabel *)category2, label[17]);				// ラベル表示 [category2]

			gtk_label_set_text((GtkLabel *)category3, label[18]);				// ラベル表示 [category3]

			gtk_label_set_text((GtkLabel *)category4, label[19]);				// ラベル表示 [category4]

			gtk_label_set_text((GtkLabel *)category5, label[20]);				// ラベル表示 [category5]

			gtk_label_set_text((GtkLabel *)category6, label[21]);				// ラベル表示 [category6]

			gtk_label_set_text((GtkLabel *)category7, label[22]);				// ラベル表示 [category7]

			gtk_label_set_text((GtkLabel *)category8, label[23]);				// ラベル表示 [category8]

			gtk_label_set_text((GtkLabel *)category9, label[24]);				// ラベル表示 [category9]

			gtk_label_set_text((GtkLabel *)category10, label[25]);				// ラベル表示 [category10]

			//-----------------------------------------------------------------------//


		//-------------------------------------------------------------------------------//


		//-- [ベクターデータ読み込み] ---------------------------------------------------//

		}else if(((atoi(message[3]) & 0x0002) == 0x00)
			&& (((atoi(message[3])) & 0x0001) == 0x0001)){					// モードチェック


			//-- [ラベル処理] -------------------------------------------------------//

			gtk_label_set_text((GtkLabel *)explanationlabel, "EXPLANATION");		// ラベル表示 [explanationlabel]
			gtk_label_set_text((GtkLabel *)locationlabel, "LOCATION");			// ラベル表示 [locationlabel]
			gtk_label_set_text((GtkLabel *)timestamplabel, "TIMESTAMP");			// ラベル表示 [timestamplabel]
			gtk_label_set_text((GtkLabel *)modelabel, "MODE");				// ラベル表示 [modelabel]
			gtk_label_set_text((GtkLabel *)mapsetlabel, "MAPSET");				// ラベル表示 [mapsetlabel]
			gtk_label_set_text((GtkLabel *)typelabel, "TYPE");				// ラベル表示 [typelabel]
			gtk_label_set_text((GtkLabel *)originxlabel, "ORIGIN X");			// ラベル表示 [originxlabel]
			gtk_label_set_text((GtkLabel *)originylabel, "ORIGIN Y");			// ラベル表示 [originylabel]
			gtk_label_set_text((GtkLabel *)sizexlabel, "SIZE X");				// ラベル表示 [sizexlabel]
			gtk_label_set_text((GtkLabel *)sizeylabel, "SIZE Y");				// ラベル表示 [sizeylabel]
			gtk_label_set_text((GtkLabel *)maporiginxlabel, "");				// ラベル表示 [maporiginxlabel]
			gtk_label_set_text((GtkLabel *)maporiginylabel, "");				// ラベル表示 [maporiginylabel]
			gtk_label_set_text((GtkLabel *)mapsizexlabel, "");				// ラベル表示 [mapsizexlabel]
			gtk_label_set_text((GtkLabel *)mapsizeylabel, "");				// ラベル表示 [mapsizeylabel]
			gtk_label_set_text((GtkLabel *)pixelsizexlabel, "");				// ラベル表示 [pixelsizexlabel]
			gtk_label_set_text((GtkLabel *)pixelsizeylabel, "");				// ラベル表示 [pixelsizeylabel]
			gtk_label_set_text((GtkLabel *)categorylabel, "");				// ラベル表示 [categorylabel]
			gtk_label_set_text((GtkLabel *)explanation, "");				// ラベル表示 [explanation]
			gtk_label_set_text((GtkLabel *)location, "");					// ラベル表示 [location]
			gtk_label_set_text((GtkLabel *)timestamp, "");					// ラベル表示 [timestamp]
			gtk_label_set_text((GtkLabel *)mode, "");					// ラベル表示 [mode]
			gtk_label_set_text((GtkLabel *)mapset, "");					// ラベル表示 [mapset]
			gtk_label_set_text((GtkLabel *)type, "");					// ラベル表示 [type]
			gtk_label_set_text((GtkLabel *)originx, "");					// ラベル表示 [originx]
			gtk_label_set_text((GtkLabel *)originy, "");					// ラベル表示 [originy]
			gtk_label_set_text((GtkLabel *)sizex, "");					// ラベル表示 [sizex]
			gtk_label_set_text((GtkLabel *)sizey, "");					// ラベル表示 [sizey]
			gtk_label_set_text((GtkLabel *)maporiginx, "");					// ラベル表示 [maporiginx]
			gtk_label_set_text((GtkLabel *)maporiginy, "");					// ラベル表示 [maporiginy]
			gtk_label_set_text((GtkLabel *)mapsizex, "");					// ラベル表示 [mapsizex]
			gtk_label_set_text((GtkLabel *)mapsizey, "");					// ラベル表示 [mapsizey]
			gtk_label_set_text((GtkLabel *)pixelsizex, "");					// ラベル表示 [pixelsizex]
			gtk_label_set_text((GtkLabel *)pixelsizey, "");					// ラベル表示 [pixelsizey]
			gtk_label_set_text((GtkLabel *)category1, "");					// ラベル表示 [category1]
			gtk_label_set_text((GtkLabel *)category2, "");					// ラベル表示 [category2]
			gtk_label_set_text((GtkLabel *)category3, "");					// ラベル表示 [category3]
			gtk_label_set_text((GtkLabel *)category4, "");					// ラベル表示 [category4]
			gtk_label_set_text((GtkLabel *)category5, "");					// ラベル表示 [category5]
			gtk_label_set_text((GtkLabel *)category6, "");					// ラベル表示 [category6]
			gtk_label_set_text((GtkLabel *)category7, "");					// ラベル表示 [category7]
			gtk_label_set_text((GtkLabel *)category8, "");					// ラベル表示 [category8]
			gtk_label_set_text((GtkLabel *)category9, "");					// ラベル表示 [category9]
			gtk_label_set_text((GtkLabel *)category10, "");					// ラベル表示 [category10]

			//-----------------------------------------------------------------------//


			//-- [ヘッダファイル処理] -----------------------------------------------//


			//-- [ヘッダファイルアドレス設定] ---------------------------------------//

			strcpy(filename, message[0]);							// robotマップアドレス
			strcat(filename, message[4]);							// 地域名
			strcat(filename, "/");								// スラッシュ
			strcat(filename, message[5]);							// 利用者マップセット
			strcat(filename, "/");								// スラッシュ
			strcat(filename, message[6]);							// データタイプ
			strcat(filename, "0000v.ini");							// ファイル名

			//-----------------------------------------------------------------------//


			//-- [ファイルオープン] -------------------------------------------------//

			fd = fopen(filename, "r");							// ファイルオープン

			if(fd == NULL){

				printf("file open error!!\n");						// メッセージ表示
				fflush(stdout);								// バッファフラッシュ [printf表示用]

				gtk_main_quit();							// メッセージループ回避

			}

			//-----------------------------------------------------------------------//


			//-- [ヘッダデータ格納] -------------------------------------------------//

			i = 0;										// カウンタリセット
			while((label[0][i] = fgetc(fd)) != ':') i++;					// ラベル格納 [explanation]
			label[0][i] = 0x00;								// 終端文字処理

			if(strcmp(label[0], "explanation") != 0){					// ラベルチェック [explanation]

				printf("headerfile:explanation error = %s\n", label[0]);		// エラーメッセージ
				fflush(stdout);								// バッファフラッシュ [printf表示用]

				gtk_main_quit();							// メッセージループ回避

			}

			strcpy(label[0], ": ");								// コロン
			i = 2;										// カウンタリセット
			while((label[0][i] = fgetc(fd)) != '\n') i++;					// データ格納 [explanation]
			label[0][i] = 0x00;								// 終端文字処理

			//-----------------------------------------------------------------------//


			//-- [ファイルクローズ] -------------------------------------------------//

			fclose(fd);									// ファイルクローズ

			//-----------------------------------------------------------------------//


			//-- [ラベル表示処理] ---------------------------------------------------//

			gtk_label_set_text((GtkLabel *)explanation, label[0]);				// ラベル表示 [explanation]

			strcpy(label[1], ": ");								// コロン
			strcat(label[1], message[0]);							// robotマップアドレス
			strcat(label[1], message[4]);							// 地域名
			gtk_label_set_text((GtkLabel *)location, label[1]);				// ラベル表示 [location]

			strcpy(label[2], ": ");								// コロン
			strcat(label[2], message[1]);							// タイムスタンプ
			gtk_label_set_text((GtkLabel *)timestamp, label[2]);				// ラベル表示 [timestamp]

			strcpy(label[3], ": ");								// コロン
			strcat(label[3], message[3]);							// アクセスモード
			gtk_label_set_text((GtkLabel *)mode, label[3]);					// ラベル表示 [mode]

			strcpy(label[4], ": ");								// コロン
			strcat(label[4], message[5]);							// 利用者マップセット名
			gtk_label_set_text((GtkLabel *)mapset, label[4]);				// ラベル表示 [mapset]

			strcpy(label[5], ": ");								// コロン
			strcat(label[5], message[6]);							// データタイプ
			gtk_label_set_text((GtkLabel *)type, label[5]);					// ラベル表示 [type]

			strcpy(label[6], ": ");								// コロン
			strcat(label[6], message[7]);							// 対象原点x座標
			gtk_label_set_text((GtkLabel *)originx, label[6]);				// ラベル表示 [originx]

			strcpy(label[7], ": ");								// コロン
			strcat(label[7], message[8]);							// 対象原点y座標
			gtk_label_set_text((GtkLabel *)originy, label[7]);				// ラベル表示 [originy]

			strcpy(label[8], ": ");								// コロン
			strcat(label[8], message[9]);							// 対象範囲x座標
			gtk_label_set_text((GtkLabel *)sizex, label[8]);				// ラベル表示 [sizex]

			strcpy(label[9], ": ");								// コロン
			strcat(label[9], message[10]);							// 対象範囲y座標
			gtk_label_set_text((GtkLabel *)sizey, label[9]);				// ラベル表示 [sizey]

			//-----------------------------------------------------------------------//


			//-----------------------------------------------------------------------//


			//-- [ノードファイル処理] -----------------------------------------------//


			//-- [ノードファイルアドレス設定] ---------------------------------------//

			strcpy(filename, message[0]);							// robotマップアドレス
			strcat(filename, message[4]);							// 地域名
			strcat(filename, "/");								// スラッシュ
			strcat(filename, message[5]);							// 利用者マップセット
			strcat(filename, "/");								// スラッシュ
			strcat(filename, message[6]);							// データタイプ
			strcat(filename, "0000v.nod");							// ファイル名

			//-----------------------------------------------------------------------//


			//-- [ファイルオープン] -------------------------------------------------//

			fd = fopen(filename, "r");							// ファイルオープン

			if(fd == NULL){

				printf("file open error!!\n");						// メッセージ表示
				fflush(stdout);								// バッファフラッシュ [printf表示用]

				gtk_main_quit();							// メッセージループ回避

			}

			//-----------------------------------------------------------------------//


			//-- [初期化] -----------------------------------------------------------//

			node_size = 0;									// ノードデータ数初期化

			//-----------------------------------------------------------------------//


			//-- [データ数チェック] -------------------------------------------------//

			while(fgets(chline, 2 * DATASIZE, fd) != NULL) node_size++;

			//-----------------------------------------------------------------------//


			//-- [ファイルクローズ] -------------------------------------------------//

			fclose(fd);									// ファイルクローズ

			//-----------------------------------------------------------------------//


			//-- [メモリ確保] -------------------------------------------------------//

			px = (long*)calloc(node_size, sizeof(long));					// メモリ確保

			if(px == NULL){

				printf("memory securing error!!\n");					// メッセージ表示
				fflush(stdout);								// バッファフラッシュ [printf表示用]

				gtk_main_quit();							// メッセージループ回避

			}

			py = (long*)calloc(node_size, sizeof(long));					// メモリ確保

			if(py == NULL){

				printf("memory securing error!!\n");					// メッセージ表示
				fflush(stdout);								// バッファフラッシュ [printf表示用]

				gtk_main_quit();							// メッセージループ回避

			}

			ptheta = (double*)calloc(node_size, sizeof(double));				// メモリ確保

			if(ptheta == NULL){

				printf("memory securing error!!\n");					// メッセージ表示
				fflush(stdout);								// バッファフラッシュ [printf表示用]

				gtk_main_quit();							// メッセージループ回避

			}

			pexplanation = (char*)calloc(node_size * DATASIZE, sizeof(char));		// メモリ確保

			if(pexplanation == NULL){

				printf("memory securing error!!\n");					// メッセージ表示
				fflush(stdout);								// バッファフラッシュ [printf表示用]

				gtk_main_quit();							// メッセージループ回避

			}

			//-----------------------------------------------------------------------//


			//-- [ファイルオープン] -------------------------------------------------//

			fd = fopen(filename, "r");							// ファイルオープン

			//-----------------------------------------------------------------------//


			//-- [ノードデータ格納] -------------------------------------------------//

			for(i = 0; i < node_size; i++)
				fscanf(fd, "%ld:%ld:%ld:%lf:%s\n", &id, (px + i), (py + i),
					(ptheta + i), (pexplanation + i * DATASIZE));			// データ格納

			//-----------------------------------------------------------------------//


			//-- [ファイルクローズ] -------------------------------------------------//

			fclose(fd);									// ファイルクローズ

			//-----------------------------------------------------------------------//


			//-- [メモリ解放] -------------------------------------------------------//

			free(ptheta);									// メモリ解放
			free(pexplanation);								// メモリ解放

			//-----------------------------------------------------------------------//


			//-----------------------------------------------------------------------//


			//-- [アークファイル処理] -----------------------------------------------//


			//-- [アークファイルアドレス設定] ---------------------------------------//

			strcpy(filename, message[0]);							// robotマップアドレス
			strcat(filename, message[4]);							// 地域名
			strcat(filename, "/");								// スラッシュ
			strcat(filename, message[5]);							// 利用者マップセット
			strcat(filename, "/");								// スラッシュ
			strcat(filename, message[6]);							// データタイプ
			strcat(filename, "0000v.arc");							// ファイル名

			//-----------------------------------------------------------------------//


			//-- [ファイルオープン] -------------------------------------------------//

			fd = fopen(filename, "r");							// ファイルオープン

			if(fd == NULL){

				printf("file open error!!\n");						// メッセージ表示
				fflush(stdout);								// バッファフラッシュ [printf表示用]

				gtk_main_quit();							// メッセージループ回避

			}

			//-----------------------------------------------------------------------//


			//-- [初期化] -----------------------------------------------------------//

			arc_size = 0;									// アークデータ数初期化

			//-----------------------------------------------------------------------//


			//-- [データ数チェック] -------------------------------------------------//

			while(fgets(chline, 2 * DATASIZE, fd) != NULL) arc_size++;			// 行数カウント

			//-----------------------------------------------------------------------//


			//-- [ファイルクローズ] -------------------------------------------------//

			fclose(fd);									// ファイルクローズ

			//-----------------------------------------------------------------------//


			//-- [メモリ確保] -------------------------------------------------------//

			pstartid = (unsigned long*)calloc(arc_size, sizeof(unsigned long));		// メモリ確保

			if(pstartid == NULL){

				printf("memory securing error!!\n");					// メッセージ表示
				fflush(stdout);								// バッファフラッシュ [printf表示用]

				gtk_main_quit();							// メッセージループ回避

			}

			pendid = (unsigned long*)calloc(arc_size, sizeof(unsigned long));		// メモリ確保

			if(pendid == NULL){

				printf("memory securing error!!\n");					// メッセージ表示
				fflush(stdout);								// バッファフラッシュ [printf表示用]

				gtk_main_quit();							// メッセージループ回避

			}

			pcost = (double*)calloc(arc_size, sizeof(double));				// メモリ確保

			if(pcost == NULL){

				printf("memory securing error!!\n");					// メッセージ表示
				fflush(stdout);								// バッファフラッシュ [printf表示用]

				gtk_main_quit();							// メッセージループ回避

			}

			//-----------------------------------------------------------------------//


			//-- [ファイルオープン] -------------------------------------------------//

			fd = fopen(filename, "r");							// ファイルオープン

			//-----------------------------------------------------------------------//


			//-- [アークデータ格納] -------------------------------------------------//

			for(i = 0; i < arc_size; i++)
				fscanf(fd, "%ld:%ld:%lf\n", (pstartid + i), (pendid + i),
					(pcost + i));							// データ格納

			//-----------------------------------------------------------------------//


			//-- [ファイルクローズ] -------------------------------------------------//

			fclose(fd);									// ファイルクローズ

			//-----------------------------------------------------------------------//


			//-- [メモリ解放] -------------------------------------------------------//

			free(pcost);									// メモリ解放

			//-----------------------------------------------------------------------//


			//-----------------------------------------------------------------------//


			//-- [描画処理] ---------------------------------------------------------//


			//-- [描画範囲処理] -----------------------------------------------------//

			min_x = *px;									// x最小値初期化
			max_x = *px;									// x最大値初期化
			min_y = *py;									// y最小値初期化
			max_y = *py;									// y最大値初期化

			for(i = 0; i < node_size; i++){

				if(min_x > *(px + i)) min_x = *(px + i);				// x最小値格納
				else if(max_x < *(px + i)) max_x = *(px + i);				// x最大値格納
				if(min_y > *(py + i)) min_y = *(py + i);				// y最小値格納
				else if(max_y < *(py + i)) max_y = *(py + i);				// y最大値格納

			}

			if(((max_x - min_x) / drawingarea->allocation.width)
				> ((max_y - min_y) / drawingarea->allocation.height))			// サイズ比較

				size = (max_x - min_x) / (double)drawingarea->allocation.width;		// サイズ格納

			else size = (max_y - min_y) / (double)drawingarea->allocation.height;		// サイズ格納

			//-----------------------------------------------------------------------//


			//-- [ノードデータ処理] -------------------------------------------------//

			for(i = 0; i < node_size; i++){

				*(px + i) = (unsigned long)((*(px + i) - min_x) / size);		// ピクセル変換
				*(py + i) = (unsigned long)((*(py + i) - min_y) / size);		// ピクセル変換
				if(*(px + i) >= drawingarea->allocation.width)
					*(px + i) = drawingarea->allocation.width - 1;			// x座標リミット
				if(*(py + i) >= drawingarea->allocation.height)
					*(py + i) = drawingarea->allocation.height - 1;			// y座標リミット

			}

			//-----------------------------------------------------------------------//


			//-- [色設定] -----------------------------------------------------------//

			drawable = drawingarea->window;							// ドローアブル初期化
			gc = gdk_gc_new(drawable);							// グラフィックコンテキスト生成

			color.red   = 0xffff;								// RED設定
			color.green = 0x0000;								// GREEN設定
			color.blue  = 0x0000;								// BLUE設定

			gdk_color_alloc(gdk_colormap_get_system(), & color);				// 色設定
			gdk_gc_set_foreground(gc, &color);						// 色割り当て

			//-----------------------------------------------------------------------//


			//-- [画像描画] ---------------------------------------------------------//

			pixbuf = gdk_pixbuf_new(GDK_COLORSPACE_RGB, FALSE, 8,
				drawingarea->allocation.width, drawingarea->allocation.height);		// バッファ生成 [pixbuf]

			width     = gdk_pixbuf_get_width(pixbuf);					// 画像幅格納
			height    = gdk_pixbuf_get_height(pixbuf);					// 画像高さ格納
			rowstride = gdk_pixbuf_get_rowstride(pixbuf);					// 一行サイズ格納
			pixels    = gdk_pixbuf_get_pixels(pixbuf);					// ピクセルデータアドレス格納

			for(i = 0; i < height; i++){

				for(j = 0; j < width; j++){

					pixels[(rowstride * i) + j * 3    ] = 0xff;			// RED設定
					pixels[(rowstride * i) + j * 3 + 1] = 0xff;			// GREEN設定
					pixels[(rowstride * i) + j * 3 + 2] = 0xff;			// BLUE設定

				}

			}

			for(i = 0; i < arc_size; i++){

				x1 = (unsigned long)(*(px + *(pstartid + i) - 1));			// x1座標設定
				y1 = (unsigned long)(height - *(py + *(pstartid + i) - 1) - 1);		// y1座標設定
				x2 = (unsigned long)(*(px + *(pendid + i) - 1));			// x2座標設定
				y2 = (unsigned long)(height - *(py + *(pendid + i) - 1) - 1);		// y2座標設定

				a = ((double)y2 - (double)y1) / ((double)x2 - (double)x1);		// 傾き設定
				b = (double)y1 - a * (double)x1;					// オフセット設定

				if((- 1.0 <= a) && (a <= 1.0)){

					if(x1 <= x2){

						for(j = x1 + 1; j < x2; j++){

							pixels[(rowstride * (long)(a * j + b)) + (long)j * 3    ]
								= 0x00;					// RED設定
							pixels[(rowstride * (long)(a * j + b)) + (long)j * 3 + 1]
								= 0xff;					// GREEN設定
							pixels[(rowstride * (long)(a * j + b)) + (long)j * 3 + 2]
								= 0x00;					// BLUE設定

						}

					}else{

						for(j = x2 + 1; j < x1; j++){

							pixels[(rowstride * (long)(a * j + b)) + (long)j * 3    ]
								= 0x00;					// RED設定
							pixels[(rowstride * (long)(a * j + b)) + (long)j * 3 + 1]
								= 0xff;					// GREEN設定
							pixels[(rowstride * (long)(a * j + b)) + (long)j * 3 + 2]
								= 0x00;					// BLUE設定

						}

					}

				}else{

					a = ((double)x2 - (double)x1) / ((double)y2 - (double)y1);	// 傾き設定
					b = (double)x1 - a * (double)y1;				// オフセット設定

					if(y1 <= y2){

						for(j = y1 + 1; j < y2; j++){

							pixels[(rowstride * (long)j) + (long)(a * j + b) * 3    ]
								= 0x00;					// RED設定
							pixels[(rowstride * (long)j) + (long)(a * j + b) * 3 + 1]
								= 0xff;					// GREEN設定
							pixels[(rowstride * (long)j) + (long)(a * j + b) * 3 + 2]
								= 0x00;					// BLUE設定

						}

					}else{

						for(j = y2 + 1; j < y1; j++){

							pixels[(rowstride * (long)j) + (long)(a * j + b) * 3    ]
								= 0x00;					// RED設定
							pixels[(rowstride * (long)j) + (long)(a * j + b) * 3 + 1]
								= 0xff;					// GREEN設定
							pixels[(rowstride * (long)j) + (long)(a * j + b) * 3 + 2]
								= 0x00;					// BLUE設定

						}

					}

				}

			}

			for(i = 0; i < arc_size; i++){

				x1 = (unsigned long)(*(px + *(pstartid + i) - 1));			// x1座標設定
				y1 = (unsigned long)(height - *(py + *(pstartid + i) - 1) - 1);		// y1座標設定
				x2 = (unsigned long)(*(px + *(pendid + i) - 1));			// x2座標設定
				y2 = (unsigned long)(height - *(py + *(pendid + i) - 1) - 1);		// y2座標設定

				pixels[(rowstride * y1) + x1 * 3    ] = 0x00;				// RED設定
				pixels[(rowstride * y1) + x1 * 3 + 1] = 0x00;				// GREEN設定
				pixels[(rowstride * y1) + x1 * 3 + 2] = 0xff;				// BLUE設定

				pixels[(rowstride * y2) + x2 * 3    ] = 0x00;				// RED設定
				pixels[(rowstride * y2) + x2 * 3 + 1] = 0x00;				// GREEN設定
				pixels[(rowstride * y2) + x2 * 3 + 2] = 0xff;				// BLUE設定

			}

			square[0] = (long)((atol(message[7]) - min_x) / size);				// 描画原点x座標設定
			square[1] = height - (long)((atol(message[8]) + atol(message[10])) / size);	// 描画原点y座標設定
			square[2] = (long)(atol(message[9])  / size);					// 描画範囲x座標設定
			square[3] = (long)(atol(message[10]) / size);					// 描画範囲y座標設定



///////////////////////////////////////////////////////////////////////////////////////////////////



			gdk_draw_pixbuf(drawingarea->window, NULL, pixbuf,
				0, 0, 0, 0, - 1, - 1, GDK_RGB_DITHER_NONE, 0, 0);			// 画像描画

			gdk_draw_rectangle(drawingarea->window, gc, FALSE, square[0], square[1],
				square[2] - 1, square[3] - 1);						// 矩形描画

			g_object_unref(gc);								// グラフィックコンテキスト解放

			//-----------------------------------------------------------------------//


			//-- [メモリ解放] -------------------------------------------------------//

			free(px);									// メモリ解放
			free(py);									// メモリ解放
			free(pstartid);									// メモリ解放
			free(pendid);									// メモリ解放

			//-----------------------------------------------------------------------//


			//-----------------------------------------------------------------------//


		}

		//-------------------------------------------------------------------------------//


	}

	//---------------------------------------------------------------------------------------//


}
//-----------------------------------------------------------------------------------------------//


//-- [エクスポーズイベント] ---------------------------------------------------------------------//
//- gboolean drawingarea_expose_event(GtkWidget *widget, GdkEventExpose *event, gpointer data)	-//
//- 機能  ：エクスポーズイベントの処理を行う							-//
//- 引数  ：(GtkWidget*)      シグナルを受けたオブジェクト [drawingarea]			-//
//-       ：(GdkEventExpose*) -									-//
//-       ：(gpointer)        シグナルハンドラ接続時にセットするユーザデータ			-//
//- 戻り値：(gboolean)        -									-//
//-----------------------------------------------------------------------------------------------//
gboolean drawingarea_expose_event(GtkWidget *widget, GdkEventExpose *event, gpointer data)
{


	//-- [変数宣言] -------------------------------------------------------------------------//

	GdkWindow *drawable;										// ドローアブル [drawable]
	GdkGC *gc;											// グラフィックコンテキスト [gc]

	//---------------------------------------------------------------------------------------//


	//-- [画像描画] -------------------------------------------------------------------------//

	if(pixbuf != NULL){


		//-- [色設定] -------------------------------------------------------------------//

		drawable = widget->window;								// ドローアブル初期化
		gc = gdk_gc_new(drawable);								// グラフィックコンテキスト生成

		color.red   = 0xffff;									// RED設定
		color.green = 0x0000;									// GREEN設定
		color.blue  = 0x0000;									// BLUE設定

		gdk_color_alloc(gdk_colormap_get_system(), & color);					// 色設定
		gdk_gc_set_foreground(gc, &color);							// 色割り当て

		//-------------------------------------------------------------------------------//

		gdk_draw_pixbuf(widget->window, NULL, pixbuf,
			0, 0, 0, 0,
			- 1, - 1, GDK_RGB_DITHER_NONE, 0, 0);						// 画像描画

		gdk_draw_rectangle(widget->window, gc, FALSE, square[0], square[1],
			square[2] - 1, square[3] - 1);							// 矩形描画

		g_object_unref(gc);									// グラフィックコンテキスト解放

	}

	//---------------------------------------------------------------------------------------//


	return TRUE;											// 戻り値 [正常終了]

}
//-----------------------------------------------------------------------------------------------//


//-- [ウィンドウ破棄イベント] -------------------------------------------------------------------//
//- void window_destroy(GtkWidget *widget)							-//
//- 機能  ：ウィンドウ破棄イベントの処理を行う							-//
//- 引数  ：(GtkWidget*) 破棄するオブジェクト							-//
//- 戻り値：(void)       なし									-//
//-----------------------------------------------------------------------------------------------//
void window_destroy(GtkWidget *widget)
{


	//-- [プログラム終了処理] ---------------------------------------------------------------//

	close(send_sock);										// ソケットディスクリプタクローズ
	close(recv_sock);										// ソケットディスクリプタクローズ
	gtk_main_quit();										// メッセージループ回避

	//---------------------------------------------------------------------------------------//


}
//-----------------------------------------------------------------------------------------------//


//-- [メイン関数] -------------------------------------------------------------------------------//
//- int main(int argc, char *argv[])								-//
//- 機能  ：(int)   コマンドライン引数の数							-//
//- 引数  ：(char*) コマンドライン引数								-//
//- 戻り値：(int)   -										-//
//-----------------------------------------------------------------------------------------------//
int main(int argc, char *argv[])
{


	//-- [変数宣言] -------------------------------------------------------------------------//

	// UDPプログラム
	char ip[16];											// IPアドレス格納配列
	char send_port[6];										// 送信ポート番号格納配列
	char recv_port[6];										// 受信ポート番号格納配列

	// GUIプログラム
	char xml_addr[DATASIZE];									// XMLファイルアドレス格納配列
	GladeXML *xml;											// GladeXML
	GtkWidget *window;										// トップレベルウィンドウ

	//---------------------------------------------------------------------------------------//


	//-- [コマンドライン引数処理] -----------------------------------------------------------//
	// 第1引数:	managementofareamap							-//
	// 第2引数:	[IPアドレス]								-//
	// 第3引数:	[送信ポート番号]	gui    -> module				-//
	// 第4引数:	[受信ポート番号]	module -> gui					-//
	//---------------------------------------------------------------------------------------//

	if(argc != 4){

		printf("argument error!!\n");								// メッセージ表示
		fflush(stdout);										// バッファフラッシュ [printf表示用]
		exit(1);										// 強制終了

	}else{

		strcpy(xml_addr, argv[0]);								// GUIプログラムアドレス取得
		strcpy(ip, argv[1]);									// IPアドレス取得
		strcpy(send_port, argv[2]);								// 送信ポート番号取得
		strcpy(recv_port, argv[3]);								// 受信ポート番号取得


		//-- [デバッグcommand line] ----------------------------------------------------//

		#ifndef DEBUG_COMMAND_LINE								// デバッグ表示開始

		printf("\n[command line]\n");								// label
		printf("command      = %s\n", xml_addr);						// command
		printf("ip           = %s\n", ip);							// ip
		printf("send port    = %s\n", send_port);						// send_port
		printf("receive port = %s\n\n", recv_port);						// recv_port
		fflush(stdout);										// バッファフラッシュ [printf表示用]

		#endif											// デバッグ表示終了

		//------------------------------------------------------------------------------//

		strcat(xml_addr, ".glade");								// XMLファイルアドレス取得

	}

	//---------------------------------------------------------------------------------------//


	//-- [初期化] ---------------------------------------------------------------------------//

	memset(send_data, 0, sizeof(send_data));							// 送信データ初期化
	memset(recv_data, 0, sizeof(recv_data));							// 受信データ初期化
	pixbuf = NULL;											// バッファ初期化 [pixbuf]

	//---------------------------------------------------------------------------------------//


	//-- [データ格納] -----------------------------------------------------------------------//

	strcpy(send_data, "success");									// 送信データ設定

	//---------------------------------------------------------------------------------------//


	//-- [ソケット作成] ---------------------------------------------------------------------//
	//-											-//
	//- プロトコル・ファミリ								-//
	//- AF_UNIX, AF_LOCAL	: ローカル通信							-//
	//- AF_INET		: IPv4 インターネットプロトコル					-//
	//- AF_INET6		: IPv6 インターネットプロトコル					-//
	//- AF_IPX		: IPX-Novellプロトコル						-//
	//- AF_NETLINK		: カーネルユーザデバイス					-//
	//- AF_X25		: ITU-T X.25/ISO-8208プロトコル					-//
	//- AF_AX25		: アマチュア無線AX.25プロトコル					-//
	//- AF_ATMPVC		: ATMPVC							-//
	//- AF_APPLETALK	: アップルトーク						-//
	//- AF_PACKET		: 低レベルパケットインターフェース				-//
	//-											-//
	//- 通信方式										-//
	//- SOCK_STREAM		: バイトストリーム	[信頼性有:順序保証有:双方向]		-//
	//- SOCK_DGRAM		: データグラム		[信頼性無:固定最大長メッセージ]		-//
	//- SOCK_SEQPACKET	: データグラム		[信頼性有:固定最大長メッセージ:双方向]	-//
	//- SOCK_RAW		: 生ネットワーク						-//
	//- SOCK_RDM		: データグラム		[信頼性有:順序保証無]			-//
	//- SOCK_PACKET		: 廃止								-//
	//---------------------------------------------------------------------------------------//

	if((send_sock = socket(AF_INET, SOCK_DGRAM, 0)) < 0){						// ソケット作成 [送信データ用]

		printf("socket error!!\n");								// メッセージ表示
		fflush(stdout);										// バッファフラッシュ [printf表示用]
		exit(1);										// 強制終了

	}

	if((recv_sock = socket(AF_INET, SOCK_DGRAM, 0)) < 0){						// ソケット作成 [受信データ用]

		printf("socket error!!\n");								// メッセージ表示
		fflush(stdout);										// バッファフラッシュ [printf表示用]
		exit(1);										// 強制終了

	}

	//---------------------------------------------------------------------------------------//


	//-- [アドレス設定] ---------------------------------------------------------------------//

	send_addr.sin_family      = AF_INET;								// アドレスファミリ
	send_addr.sin_port        = htons(atoi(send_port));						// ポート番号 [バイトオーダ]
	send_addr.sin_addr.s_addr = inet_addr(ip);							// IPアドレス [バイトオーダ]

	recv_addr.sin_family      = AF_INET;								// アドレスファミリ
	recv_addr.sin_port        = htons(atoi(recv_port));						// ポート番号 [バイトオーダ]
	recv_addr.sin_addr.s_addr = inet_addr(ip);							// IPアドレス [バイトオーダ]

	//---------------------------------------------------------------------------------------//


	//-- [受信設定] -------------------------------------------------------------------------//

	bind(recv_sock, (struct sockaddr *)&recv_addr, sizeof(recv_addr));				// バインド [受信データ]
	addr_size = sizeof(recv_addr);									// アドレス格納構造体サイズ格納

	//---------------------------------------------------------------------------------------//


	//-- [GTK+初期化] -----------------------------------------------------------------------//

	gtk_init(&argc, &argv);										// GTK+初期化

	if(!(xml = glade_xml_new(xml_addr, NULL, NULL))){						// データ読み込み

		printf("glade file error.\n");								// メッセージ表示
		return 1;										// 戻り値 [異常終了]

	}


	//-- [ウィジェット生成] -----------------------------------------------------------------//

	window           = glade_xml_get_widget(xml, "window");						// ウィンドウ生成 [window]
	drawingarea      = glade_xml_get_widget(xml, "drawingarea");					// 画像生成 [drawingarea]
	explanationlabel = glade_xml_get_widget(xml, "explanationlabel");				// ラベル生成 [explanationlabel]
	locationlabel    = glade_xml_get_widget(xml, "locationlabel");					// ラベル生成 [locationlabel]
	timestamplabel   = glade_xml_get_widget(xml, "timestamplabel");					// ラベル生成 [timestamplabel]
	modelabel        = glade_xml_get_widget(xml, "modelabel");					// ラベル生成 [modelabel]
	mapsetlabel      = glade_xml_get_widget(xml, "mapsetlabel");					// ラベル生成 [mapsetlabel]
	typelabel        = glade_xml_get_widget(xml, "typelabel");					// ラベル生成 [typelabel]
	originxlabel     = glade_xml_get_widget(xml, "originxlabel");					// ラベル生成 [originxlabel]
	originylabel     = glade_xml_get_widget(xml, "originylabel");					// ラベル生成 [originylabel]
	sizexlabel       = glade_xml_get_widget(xml, "sizexlabel");					// ラベル生成 [sizexlabel]
	sizeylabel       = glade_xml_get_widget(xml, "sizeylabel");					// ラベル生成 [sizeylabel]
	maporiginxlabel  = glade_xml_get_widget(xml, "maporiginxlabel");				// ラベル生成 [maporiginxlabel]
	maporiginylabel  = glade_xml_get_widget(xml, "maporiginylabel");				// ラベル生成 [maporiginylabel]
	mapsizexlabel    = glade_xml_get_widget(xml, "mapsizexlabel");					// ラベル生成 [mapsizexlabel]
	mapsizeylabel    = glade_xml_get_widget(xml, "mapsizeylabel");					// ラベル生成 [mapsizeylabel]
	pixelsizexlabel  = glade_xml_get_widget(xml, "pixelsizexlabel");				// ラベル生成 [pixelsizexlabel]
	pixelsizeylabel  = glade_xml_get_widget(xml, "pixelsizeylabel");				// ラベル生成 [pixelsizeylabel]
	categorylabel    = glade_xml_get_widget(xml, "categorylabel");					// ラベル生成 [categorylabel]
	explanation      = glade_xml_get_widget(xml, "explanation");					// ラベル生成 [explanation]
	location         = glade_xml_get_widget(xml, "location");					// ラベル生成 [location]
	timestamp        = glade_xml_get_widget(xml, "timestamp");					// ラベル生成 [timestamp]
	mode             = glade_xml_get_widget(xml, "mode");						// ラベル生成 [mode]
	mapset           = glade_xml_get_widget(xml, "mapset");						// ラベル生成 [mapset]
	type             = glade_xml_get_widget(xml, "type");						// ラベル生成 [type]
	originx          = glade_xml_get_widget(xml, "originx");					// ラベル生成 [originx]
	originy          = glade_xml_get_widget(xml, "originy");					// ラベル生成 [originy]
	sizex            = glade_xml_get_widget(xml, "sizex");						// ラベル生成 [sizex]
	sizey            = glade_xml_get_widget(xml, "sizey");						// ラベル生成 [sizey]
	maporiginx       = glade_xml_get_widget(xml, "maporiginx");					// ラベル生成 [maporiginx]
	maporiginy       = glade_xml_get_widget(xml, "maporiginy");					// ラベル生成 [maporiginy]
	mapsizex         = glade_xml_get_widget(xml, "mapsizex");					// ラベル生成 [mapsizex]
	mapsizey         = glade_xml_get_widget(xml, "mapsizey");					// ラベル生成 [mapsizey]
	pixelsizex       = glade_xml_get_widget(xml, "pixelsizex");					// ラベル生成 [pixelsizex]
	pixelsizey       = glade_xml_get_widget(xml, "pixelsizey");					// ラベル生成 [pixelsizey]
	category1        = glade_xml_get_widget(xml, "category1");					// ラベル生成 [category1]
	category2        = glade_xml_get_widget(xml, "category2");					// ラベル生成 [category2]
	category3        = glade_xml_get_widget(xml, "category3");					// ラベル生成 [category3]
	category4        = glade_xml_get_widget(xml, "category4");					// ラベル生成 [category4]
	category5        = glade_xml_get_widget(xml, "category5");					// ラベル生成 [category5]
	category6        = glade_xml_get_widget(xml, "category6");					// ラベル生成 [category6]
	category7        = glade_xml_get_widget(xml, "category7");					// ラベル生成 [category7]
	category8        = glade_xml_get_widget(xml, "category8");					// ラベル生成 [category8]
	category9        = glade_xml_get_widget(xml, "category9");					// ラベル生成 [category9]
	category10       = glade_xml_get_widget(xml, "category10");					// ラベル生成 [category10]

	//---------------------------------------------------------------------------------------//


	//-- [フォント設定] ---------------------------------------------------------------------//

	gtk_widget_modify_font(explanationlabel, pango_font_description_from_string(FONTSTYLE));	// フォント設定 [explanationlabel]
	gtk_widget_modify_font(locationlabel, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [locationlabel]
	gtk_widget_modify_font(timestamplabel, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [timestamplabel]
	gtk_widget_modify_font(modelabel, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [modelabel]
	gtk_widget_modify_font(mapsetlabel, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [mapsetlabel]
	gtk_widget_modify_font(typelabel, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [typelabel]
	gtk_widget_modify_font(originxlabel, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [originxlabel]
	gtk_widget_modify_font(originylabel, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [originylabel]
	gtk_widget_modify_font(sizexlabel, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [sizexlabel]
	gtk_widget_modify_font(sizeylabel, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [sizeylabel]
	gtk_widget_modify_font(maporiginxlabel, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [maporiginxlabel]
	gtk_widget_modify_font(maporiginylabel, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [maporiginylabel]
	gtk_widget_modify_font(mapsizexlabel, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [mapsizexlabel]
	gtk_widget_modify_font(mapsizeylabel, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [mapsizeylabel]
	gtk_widget_modify_font(pixelsizexlabel, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [pixelsizexlabel]
	gtk_widget_modify_font(pixelsizeylabel, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [pixelsizeylabel]
	gtk_widget_modify_font(categorylabel, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [categorylabel]
	gtk_widget_modify_font(explanation, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [explanation]
	gtk_widget_modify_font(location, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [location]
	gtk_widget_modify_font(timestamp, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [timestamp]
	gtk_widget_modify_font(mode, pango_font_description_from_string(FONTSTYLE));			// フォント設定 [mode]
	gtk_widget_modify_font(mapset, pango_font_description_from_string(FONTSTYLE));			// フォント設定 [mapset]
	gtk_widget_modify_font(type, pango_font_description_from_string(FONTSTYLE));			// フォント設定 [type]
	gtk_widget_modify_font(originx, pango_font_description_from_string(FONTSTYLE));			// フォント設定 [originx]
	gtk_widget_modify_font(originy, pango_font_description_from_string(FONTSTYLE));			// フォント設定 [originy]
	gtk_widget_modify_font(sizex, pango_font_description_from_string(FONTSTYLE));			// フォント設定 [sizex]
	gtk_widget_modify_font(sizey, pango_font_description_from_string(FONTSTYLE));			// フォント設定 [sizey]
	gtk_widget_modify_font(maporiginx, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [maporiginx]
	gtk_widget_modify_font(maporiginy, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [maporiginy]
	gtk_widget_modify_font(mapsizex, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [mapsizex]
	gtk_widget_modify_font(mapsizey, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [mapsizey]
	gtk_widget_modify_font(pixelsizex, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [pixelsizex]
	gtk_widget_modify_font(pixelsizey, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [pixelsizey]
	gtk_widget_modify_font(category1, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [category1]
	gtk_widget_modify_font(category2, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [category2]
	gtk_widget_modify_font(category3, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [category3]
	gtk_widget_modify_font(category4, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [category4]
	gtk_widget_modify_font(category5, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [category5]
	gtk_widget_modify_font(category6, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [category6]
	gtk_widget_modify_font(category7, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [category7]
	gtk_widget_modify_font(category8, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [category8]
	gtk_widget_modify_font(category9, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [category9]
	gtk_widget_modify_font(category10, pango_font_description_from_string(FONTSTYLE));		// フォント設定 [category10]

	//---------------------------------------------------------------------------------------//


	glade_xml_signal_autoconnect(xml);								// コールバック関数接続
	gtk_widget_show(window);									// ウィンドウ表示

	//---------------------------------------------------------------------------------------//


	//-- [ソケットディスクリプタ登録] -------------------------------------------------------//

	gdk_input_add(recv_sock, GDK_INPUT_READ, udp_read_callback, NULL);				// コールバック関数登録

	//---------------------------------------------------------------------------------------//


	//-- [イベントループ] -------------------------------------------------------------------//

	gtk_main();											// イベントループ

	//---------------------------------------------------------------------------------------//


	return 0;											// 戻り値 [正常終了]

}
//-----------------------------------------------------------------------------------------------//
